﻿Imports Infragistics.Controls.Menus

Class MainWindow

	Private parsedNodes As List(Of XamDataTreeNode)

	Public Sub New()

		' This call is required by the designer.
		InitializeComponent()
		Me.DataContext = New ViewModel()
		' Add any initialization after the InitializeComponent() call.

	End Sub

	Private Sub _MenuTree_NodeCheckedChanged(sender As Object, e As Infragistics.Controls.Menus.NodeEventArgs)

		If parsedNodes Is Nothing Then parsedNodes = New List(Of XamDataTreeNode)
		parsedNodes.Add(e.Node)

		Dim MenuItem = DirectCast(e.Node.Data, clsMenuItem)

		If e.Node.IsChecked Then
			MessageBox.Show("You checked " + MenuItem.Description)
		Else
			MessageBox.Show(MenuItem.Description + " got checked.")
		End If

		If e.Node.IsSelected Then
			MessageBox.Show("You selected " + MenuItem.Description)
		Else
			MessageBox.Show(MenuItem.Description + " got selected.")
		End If

		If e.Node.IsActive Then
			MessageBox.Show(MenuItem.Description + " is active.")
		Else
			MessageBox.Show(MenuItem.Description + " got activated.")
		End If

		If e.Node.IsEditing Then
			MessageBox.Show(MenuItem.Description + " is editing.")
		Else
			MessageBox.Show(MenuItem.Description + " is being edited.")
		End If

		Dim i As Integer = 100
		'If Not e.Node.HasChildren Then parsedNodes = Nothing

	End Sub

	Private Function GetNodeHierarchy(InNode As XamDataTreeNode) As XamDataTreeNode

		Dim nodeToAdd, currentNode, parentNode As XamDataTreeNode

		currentNode = InNode
		parentNode = currentNode.Manager.ParentNode

		While (parentNode IsNot Nothing)

			'DirectCast(parentNode.Data, clsMenuItem).Children.Remove(Function(m) m.ID <> DirectCast(currentNode.Data, clsMenuItem).ID)
			currentNode = parentNode
			parentNode = currentNode.Manager.ParentNode

		End While

		nodeToAdd = parentNode
		Return nodeToAdd

	End Function
End Class
