﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel

Public Class ViewModel

    Public Property Menus() As ObservableCollection(Of clsMenuItem)
        Get
            Return m_Menus
        End Get
        Set(value As ObservableCollection(Of clsMenuItem))
            m_Menus = value
        End Set
    End Property
    Private m_Menus As ObservableCollection(Of clsMenuItem)
    Public Property SelectedMenuItems() As Object()
        Get
            Return m_SelectedMenuItems
        End Get
        Set(value As Object())
            m_SelectedMenuItems = value
        End Set
    End Property
    Private m_SelectedMenuItems As Object()

    Private NoLevels As Integer = 1
    Public Sub New()
        CreateData()
    End Sub

	Private RootList As String() = {"Current Menu", "New Menu", "Old Menu", "Buffet Menu", "Holiday Menu", "Special Menu", _
	"Elegant Menu", "Family Menu", "Small Affair Menu", "Local Menu"}

	Private ChildList As String() = {"Current Menu Child", "New Menu Child", "Old Menu Child", "Buffet Menu Child", "Holiday Menu Child", "Special Menu Child", _
	"Elegant Menu Child", "Family Menu Child", "Small Affair Menu Child", "Local Menu Child"}


	Private Sub CreateData()
		Dim r As New Random()
		Menus = New ObservableCollection(Of clsMenuItem)()
		For i As Integer = 0 To 9
		Dim gd As New clsMenuItem() With { _
			.ID = i, _
			.Description = RootList(r.[Next](10)), _
			.IsSelected = False, _
			.Children = New ObservableCollection(Of clsMenuItem)() _
		}
			AddChildren(gd, 2)
			Menus.Add(gd)
		Next

		''Menus[0].IsSelected = true;
		'Menus(0).Children(1).IsSelected = True

		'Menus(1).Children(0).IsSelected = True

		'Menus(1).Children(2).IsSelected = True

		For Each menu As Object In Menus
			Dim childCnt As Integer = menu.Children.Count()
			Dim selCnt As Integer = 0
			For i As Integer = 0 To menu.Children.Count() - 1
				If menu.Children(i).IsSelected = True Then
					selCnt += 1
				End If
			Next

			If selCnt > 0 Then
				If selCnt = childCnt Then
					menu.IsSelected = True
				Else
					menu.IsSelected = Nothing
				End If

			End If
		Next


		'For i As Integer = 0 To Menus(3).Children.Count() - 1
		'	Menus(3).Children(i).IsSelected = True
		'Next


		'Menus(3).IsSelected = True


		Menus(3).Children(0).Children.Add(New clsMenuItem() With {
											.ID = 100,
											.Description = "Level 2 Child 1",
											.IsSelected = False,
											.Children = New ObservableCollection(Of clsMenuItem)()
											})
		Menus(3).Children(0).Children.Add(New clsMenuItem() With {
											.ID = 101,
											.Description = "Level 2 Child 2",
											.IsSelected = False,
											.Children = New ObservableCollection(Of clsMenuItem)()
											})


	End Sub


	Private Sub AddChildren(gd As clsMenuItem, levelNo As Integer)
		Dim r As New Random()
		Dim NoChildren As Integer = r.[Next](3, 15)
		Dim levelStr As String = "1"
		For i As Integer = 0 To levelNo - 1
			levelStr += "0"
		Next


		Dim levelMult As Integer = Integer.Parse(levelStr)
		For i As Integer = 0 To NoChildren - 1
			Dim gd2 As New clsMenuItem() With { _
				.ID = levelMult + i, _
				.Description = ChildList(r.[Next](10)), _
				.IsSelected = False, _
				.Children = New ObservableCollection(Of clsMenuItem)() _
			}

			If levelNo < NoLevels Then
				AddChildren(gd2, levelNo + 1)
			End If

			gd.Children.Add(gd2)
		Next
	End Sub

End Class

Public Class clsMenuItem
		Implements INotifyPropertyChanged


	Private m_id As Integer
	Private name As String
	Private m_isSelected As Boolean

	Public Property Children() As ObservableCollection(Of clsMenuItem)
		Get
			Return m_Children
		End Get
		Set(value As ObservableCollection(Of clsMenuItem))
			m_Children = value
		End Set
	End Property
	Private m_Children As ObservableCollection(Of clsMenuItem)


	Public Property ID() As Integer
		Get
			Return m_id
		End Get
		Set(value As Integer)
			If m_id <> value Then
				m_id = value
				OnPropertyChanged("ID")
			End If
		End Set
	End Property

	Public Property Description() As String
		Get
			Return name
		End Get
		Set(value As String)
			If name <> value Then
				name = value
				OnPropertyChanged("Description")
			End If
		End Set
	End Property

	Public Property IsSelected() As Boolean
		Get
			Return m_isSelected
		End Get
		Set(value As Boolean)
			If m_isSelected <> value Then
				m_isSelected = value
				OnPropertyChanged("IsSelected")
			End If
		End Set
	End Property


	Public Event PropertyChanged(sender As Object, e As PropertyChangedEventArgs) Implements INotifyPropertyChanged.PropertyChanged
	Protected Sub OnPropertyChanged(propertyName As String)

		Try
			Dim propEventArgs As New PropertyChangedEventArgs(propertyName)
			RaiseEvent PropertyChanged(Me, propEventArgs)
		Catch

		End Try
	End Sub

End Class


Public Class VisConverter
    Implements IValueConverter


    Public Function Convert(value As Object, targetType As Type, parameter As Object, culture As Globalization.CultureInfo) As Object Implements IValueConverter.Convert
        If TypeOf value Is Boolean AndAlso CBool(value) = True AndAlso parameter.ToString().Equals("true") Then
            Return Visibility.Visible
        End If
        If TypeOf value Is Boolean AndAlso CBool(value) = False AndAlso parameter.ToString().Equals("false") Then
            Return Visibility.Visible
        End If

        Return Visibility.Collapsed
    End Function

    Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
